#include <Arduino.h>
#include "web/web.h"
#include "config.h"

#include <Wire.h>

Adafruit_Si4713* radio;

void do_i2c_scan() {
    Serial.println();
    Serial.println("I2C scanner. Scanning ...");
    byte count = 0;

    Wire.begin();
    for (byte i = 8; i < 120; i++) {
        Wire.beginTransmission(i); // Begin I2C transmission Address (i)
        if (Wire.endTransmission() == 0) {
            // Receive 0 = success (ACK response)
            Serial.print("Found address: ");
            Serial.print(i, DEC);
            Serial.print(" (0x");
            Serial.print(i, HEX); // PCF8574 7 bit address
            Serial.println(")");
            count++;
        }
    }
    Serial.print("Found ");
    Serial.print(count, DEC); // numbers of devices
    Serial.println(" device(s).");
}


[[noreturn]] void application() {
    radio = new Adafruit_Si4713(FM_RST_PIN);

    IF_DEBUG {
        Serial.begin(115200);
    }

    Serial.println("Adafruit Radio - Si4713 Test");

    if (!radio->begin()) {  // begin with address 0x63 (CS high default)
        Serial.println("Couldn't find radio?");
        Serial.println("Run I2C scanner...");
        do_i2c_scan();
        while (1);
    }

    // Uncomment to scan power of entire range from 87.5 to 108.0 MHz
    /*
    for (uint16_t f  = 8750; f<10800; f+=10) {
     radio.readTuneMeasure(f);
     Serial.print("Measuring "); Serial.print(f); Serial.print("...");
     radio.readTuneStatus();
     Serial.println(radio.currNoiseLevel);
     }
     */

    Serial.print("\nSet TX power");
    radio->setTXpower(115, 55);  // dBuV, 88-115 max, cap надо задать 0 и посмотреть сколько будет

    Serial.print("\nTuning into freq");
    radio->tuneFM(10740); // 100.0 mhz

    // This will tell you the status in case you want to read it from the chip
    radio->readTuneStatus();
    Serial.printf("Curr tuned: freq=%d, freqdBuV=%d, ANTcap=%d\n",
                  radio->currFreq, radio->currdBuV, radio->currAntCap);

    // begin the RDS/RDBS transmission
    radio->beginRDS();
    radio->setRDSstation((char*)"FUCK YOU!1!");
    radio->setRDSbuffer( (char*)"Fisting is 300 bucks");

    Serial.println("RDS on!");

    webThread();
}


// Остатки ардуиновского мусора

void setup() {
    application();
//    fuck();
}
void loop() { /* делаем ровно них*я */ }